<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/22/2004 *
 * ===================                          Last change: 09/22/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_order.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Configuration for order page                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Konfiguration der Mailbuchungsseite              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if (isFormSent()) {
	// Save data
	adminSaveSettingsFromPostData();
} else {
	// Init all selection entries
	foreach (array('order_max_full_order', 'order_max_full_max', 'order_mode_asc', 'order_mode_desc', 'allow_url_in_text_y', 'allow_url_in_text_n', 'allow_url_in_subject_y', 'allow_url_in_subject_n', 'url_blacklist_y', 'url_blacklist_n', 'repay_deleted_mails_repay', 'repay_deleted_mails_jackpot', 'repay_deleted_mails_shred') as $entry) {
		$content[$entry] = '';
	} // END - foreach

	// Set all default checks
	foreach (array('order_max_full', 'order_mode', 'allow_url_in_text', 'allow_url_in_subject', 'url_blacklist') as $entry) {
		$content[$entry . '_' . strtolower(getConfig($entry))] = ' checked="checked"';
	} // END - foreach

	// Set all default selections
	foreach (array('repay_deleted_mails') as $entry) {
		$content[$entry . '_' . strtolower(getConfig($entry))] = ' selected="selected"';
	} // END - foreach

	// Selection list
	$content['order_selection'] = addOrderSelectionOptions(getConfig('order_select'));

	// Load template
	loadTemplate('admin_config_order', false, $content);
}

// [EOF]
?>
