<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/28/2003 *
 * ===================                          Last change: 06/10/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-lock_user.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Lock members                                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mitglieder sperren                               *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Is a userid set?
if (isGetRequestParameterSet('userid')) {
	// Action not performed by default
	$isActive = false;

	// Load user's data
	if (fetchUserData(getRequestParameter('userid'))) {
		// Is a lock reason set?
		if ((isFormSent('lock')) && (getUserData('status') != 'LOCKED')) {
			// Ok, lock the account!
			if (isExtensionInstalledAndNewer('user', '0.3.5')) {
				// Lock with reason
				SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `status`='LOCKED', `lock_reason`='%s', `lock_timestamp`=NOW() WHERE `userid`=%s LIMIT 1",
					array(postRequestParameter('reason'), bigintval(getRequestParameter('userid'))), __FILE__, __LINE__);
			} else {
				// Lock with no lock reason saved
				SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `status`='LOCKED' WHERE `userid`=%s LIMIT 1",
					array(bigintval(getRequestParameter('userid'))), __FILE__, __LINE__);
			}

			// Entry updated?
			if (SQL_AFFECTEDROWS() == 1) {
				// Send an email to the user! In later version you can optionally switch this feature off
				$message = loadEmailTemplate('lock-user', array('text' => postRequestParameter('reason')), bigintval(getRequestParameter('userid')));

				// Send away...
				sendEmail(bigintval(getRequestParameter('userid')), '{--ADMIN_LOCKED_SUBJECT--}', $message);
			} // END - if

			// Prepare message
			$message = getMaskedMessage('ADMIN_USER_ACCOUNT_LOCKED', bigintval(getRequestParameter('userid')));
			$isActive = true;
		} elseif ((isPostRequestParameterSet('unlock')) && (getUserData('status') == 'LOCKED')) {
			// Ok, unlock the account!
			if (isExtensionInstalledAndNewer('user', '0.3.5')) {
				// Reset lock reason as well
				SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_user_data`
SET
	`status`='CONFIRMED',
	`lock_reason`='',
	`lock_timestamp`='0000-00-00 00:00'
WHERE
	`userid`=%s
LIMIT 1",
					array(bigintval(getRequestParameter('userid'))), __FILE__, __LINE__);
			} else {
				// No lock reason to reset
				SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `status`='CONFIRMED' WHERE `userid`=%s LIMIT 1",
					array(bigintval(getRequestParameter('userid'))), __FILE__, __LINE__);
			}

			// Entry updated?
			if (SQL_AFFECTEDROWS() == 1) {
				// Send an email to the user! In later version you can optionally switch this feature off
				$message = loadEmailTemplate('unlock-user', array('text' => postRequestParameter('reason')), bigintval(getRequestParameter('userid')));

				// Send away...
				sendEmail(bigintval(getRequestParameter('userid')), '{--ADMIN_UNLOCKED_SUBJECT--}', $message);
				if (isExtensionActive('rallye')) {
					addUserToReferalRallye(getRequestParameter('userid'));
				} // END - if
			} // END - if

			// Prepare message
			$message = getMaskedMessage('ADMIN_USER_ACCOUNT_UNLOCKED', bigintval(getRequestParameter('userid')));
			$isActive = true;
		} elseif (isFormSent('del')) {
			// Delete the account
			$isActive = true;
			loadIncludeOnce('inc/modules/admin/what-del_user.php');
		} elseif (isPostRequestParameterSet('no')) {
			// Do not lock him...
			$url = adminCreateUserLink(getRequestParameter('userid'));
		} else {
			// Load user data we need
			if (fetchUserData(getRequestParameter('userid'))) {
				// Transfer data to constants for the template
				$content['userid']  = getRequestParameter('userid');

				// Realy want to lock?
				switch (getUserData('status')) {
					case 'CONFIRMED': // Yes, lock him down... ;-)
						$content['ok']     = 'lock';
						$content['header'] = getMaskedMessage('ADMIN_HEADER_LOCK_ACCOUNT', $content['userid']);
						$content['text']   = getMaskedMessage('ADMIN_TEXT_LOCK_ACCOUNT', $content['userid']);
						break;

					case 'LOCKED': // Unlock the user
						$content['ok']     = 'unlock';
						$content['header'] = getMaskedMessage('ADMIN_HEADER_UNLOCK_ACCOUNT', $content['userid']);
						$content['text']   = getMaskedMessage('ADMIN_TEXT_UNLOCK_ACCOUNT', $content['userid']);
						break;

					case 'UNCONFIRMED': // Unconfirmed accounts cannot be unlocked!
						$content['ok'] = 'del';
						$content['header'] = getMaskedMessage('ADMIN_HEADER_DELETE_ACCOUNT', $content['userid']);
						$content['text']   = getMaskedMessage('ADMIN_TEXT_DELETE_ACCOUNT', $content['userid']);
						break;
				}

				// Output form
				loadTemplate('admin_lock_user', false, $content);
			} else {
				// Account does not exists!
				loadTemplate('admin_settings_unsaved', false, getMaskedMessage('ADMIN_MEMBER_404', bigintval(getRequestParameter('userid'))) . '</div>');
			}
		}

		// Is an URL set?
		if (!empty($url)) {
			// Reload and die...
			redirectToUrl($url);
		} elseif ($isActive) {
			// An action was performed...
			if (!empty($message)) {
				loadTemplate('admin_settings_unsaved', false, $message);
			} else {
				loadTemplate('admin_settings_saved', false, '{--ADMIN_USER_UPDATED--}');
			}
		}
	} else {
		// Account does not exists!
		loadTemplate('admin_settings_unsaved', false, getMaskedMessage('ADMIN_MEMBER_404', bigintval(getRequestParameter('userid'))));
	}
} else {
	// List all users
	addMemberSelectionBox();
}

// [EOF]
?>
